//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaMaracasVisuManualContourModel_Box.h"
#include "bbcreaMaracasVisuPackage.h"

#include <creaContoursFactory.h>


namespace bbcreaMaracasVisu
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaMaracasVisu,ManualContourModel_Box)
BBTK_BLACK_BOX_IMPLEMENTATION(ManualContourModel_Box,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ManualContourModel_Box::Process()
{

// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')

//    bbSetOutputOut( bbGetInputIn() );
//    std::cout << "Output value = " <<bbGetOutputOut() << std::endl;
  	
	creaContoursFactory f;
	manualContourModel 	*m;
	std::vector<double> lstX;
	std::vector<double> lstY;
	std::vector<double> lstZ;
	int i,size;
	double x,y,z;

	m = (manualContourModel*)f.getContourModel( bbGetInputType() );
	m->SetNumberOfPointsSpline( bbGetInputNbPoints() );
	m->SetCloseContour( bbGetInputOpenClose() );
	size = bbGetInputLstControlPointsX().size();
	for (i=0;i<size;i++)
	{
//		m->InsertPoint( bbGetInputLstControlPointsX()[i] , bbGetInputLstControlPointsY()[i] , bbGetInputLstControlPointsZ()[i] );
		m->AddPoint( bbGetInputLstControlPointsX()[i] , bbGetInputLstControlPointsY()[i] , bbGetInputLstControlPointsZ()[i] );
	} // for
	m->UpdateSpline();
	size = bbGetInputNbPoints();
	for (i=0;i<size;i++)
	{
		m->GetSpline_i_Point(i,&x,&y,&z);
		lstX.push_back(x);
		lstY.push_back(y);
		lstZ.push_back(z);
	} // for
	bbSetOutputLstContourPointsX(lstX);
	bbSetOutputLstContourPointsY(lstY);
	bbSetOutputLstContourPointsZ(lstZ);

	delete m;

}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ManualContourModel_Box::bbUserSetDefaultValues()
{

//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
   bbSetInputType(1);
   bbSetInputOpenClose(false);
   bbSetInputNbPoints(100);
  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ManualContourModel_Box::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ManualContourModel_Box::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
  
}
}
// EO namespace bbcreaMaracasVisu


